/*
  Copyright 2001,2002 Colin Percival and the University of Oxford

  Copyright in this software is held by the University of Oxford
  and Colin Percival. Both the University of Oxford and Colin Percival
  have agreed that this software may be distributed free of charge and
  in accordance with the attached licence.

  The above notwithstanding, in order that the University as a
  charitable foundation protects its assets for the benefit of its
  educational and research purposes, the University makes clear that no
  condition is made or to be implied, nor is any warranty given or to
  be implied, as to the proper functioning of this work, or that it
  will be suitable for any particular purpose or for use under any
  specific conditions.  Furthermore, the University disclaims all
  responsibility for any use which is made of this work.

  For the terms under which this work may be distributed, please see
  the adjoining file "LICENSE".
*/

#ifndef PTYPES_H
#define PTYPES_H

#include <sys/types.h>

typedef __uint8_t uint8;
typedef __uint32_t uint32;

#define bswap32(x) (((x<<24)&0xFF000000)|((x<<8)&0x00FF0000)|(((uint32)x>>8)&0x0000FF00)|(((uint32)x>>24)&0x000000FF))

#if BYTE_ORDER == LITTLE_ENDIAN
#define int32_little(x) (x)
#else
#define int32_little(x) bswap32(x)
#endif

#endif
